
#property copyright "Copyright ?2004, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net/"

#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1 Silver
#property indicator_color2 Red
#property indicator_color3 Green
#property indicator_color4 Red

extern int FastEMA = 12;
extern int SlowEMA = 26;
extern int SignalSMA = 9;
double g_ibuf_88[];
double g_ibuf_92[];
double g_ibuf_96[];
double g_ibuf_100[];
int g_bars_104 = 0;
int g_bars_108 = 0;
int g_bars_112 = 0;
int g_bars_116 = 0;

int init() {
   SetIndexStyle(0, DRAW_HISTOGRAM);
   SetIndexStyle(1, DRAW_LINE);
   SetIndexDrawBegin(1, SignalSMA);
   IndicatorDigits(Digits + 1);
   SetIndexBuffer(0, g_ibuf_88);
   SetIndexBuffer(1, g_ibuf_92);
   SetIndexBuffer(2, g_ibuf_96);
   SetIndexBuffer(3, g_ibuf_100);
   IndicatorShortName("MACD Alert(" + FastEMA + "," + SlowEMA + "," + SignalSMA + ")");
   SetIndexLabel(0, "MACD");
   SetIndexLabel(1, "Signal");
   return (0);
}

int deinit() {
   return (0);
}

int start() {
   int li_0 = IndicatorCounted();
   if (li_0 > 0) li_0--;
   int l_bars_4 = Bars;
   for (int li_8 = 0; li_8 < l_bars_4; li_8++) g_ibuf_88[li_8] = iMA(NULL, 0, FastEMA, 0, MODE_EMA, PRICE_CLOSE, li_8) - iMA(NULL, 0, SlowEMA, 0, MODE_EMA, PRICE_CLOSE, li_8);
   for (li_8 = 0; li_8 < l_bars_4; li_8++) g_ibuf_92[li_8] = iMAOnArray(g_ibuf_88, Bars, SignalSMA, 0, MODE_SMA, li_8);
   for (li_8 = 0; li_8 < l_bars_4; li_8++) {
      if (g_ibuf_88[li_8] > g_ibuf_92[li_8]) g_ibuf_96[li_8] = g_ibuf_88[li_8];
      else g_ibuf_100[li_8] = g_ibuf_88[li_8];
   }
   if (g_ibuf_96[1] == g_ibuf_88[1] && g_ibuf_96[2] != g_ibuf_88[2]) AlertOnce(Symbol() + " MACD: Long signal!", 0);
   if (g_ibuf_100[1] == g_ibuf_88[1] && g_ibuf_100[2] != g_ibuf_88[2]) AlertOnce(Symbol() + " MACD: Short signal!", 1);
   return (0);
}

int AlertOnce(string as_0, int ai_8) {
   switch (ai_8) {
   case 1:
      if (g_bars_104 == 0 || g_bars_104 < Bars) {
         Alert(as_0);
         g_bars_104 = Bars;
         return (1);
      }
      break;
   case 2:
      if (g_bars_108 == 0 || g_bars_108 < Bars) {
         Alert(as_0);
         g_bars_108 = Bars;
         return (1);
      }
      break;
   case 3:
      if (g_bars_112 == 0 || g_bars_112 < Bars) {
         Alert(as_0);
         g_bars_112 = Bars;
         return (1);
      }
      break;
   case 4:
      if (g_bars_116 == 0 || g_bars_116 < Bars) {
         Alert(as_0);
         g_bars_116 = Bars;
         return (1);
      }
      break;
   }
   return (0);
}